// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/oapi-codegen/oapi-codegen/v2 version v2.4.1 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	"github.com/oapi-codegen/runtime"
	openapi_types "github.com/oapi-codegen/runtime/types"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	V1 AzureUploadOptionsHyperVGeneration = "V1"
	V2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"
	BlueprintCustomizationsPartitioningModeLvm     BlueprintCustomizationsPartitioningMode = "lvm"
	BlueprintCustomizationsPartitioningModeRaw     BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for BtrfsVolumeType.
const (
	Btrfs BtrfsVolumeType = "btrfs"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"
	ComposeStatusValuePending ComposeStatusValue = "pending"
	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"
	CustomizationsPartitioningModeLvm     CustomizationsPartitioningMode = "lvm"
	CustomizationsPartitioningModeRaw     CustomizationsPartitioningMode = "raw"
)

// Defines values for DiskType.
const (
	Dos DiskType = "dos"
	Gpt DiskType = "gpt"
)

// Defines values for FilesystemTypedFsType.
const (
	FilesystemTypedFsTypeExt4 FilesystemTypedFsType = "ext4"
	FilesystemTypedFsTypeVfat FilesystemTypedFsType = "vfat"
	FilesystemTypedFsTypeXfs  FilesystemTypedFsType = "xfs"
)

// Defines values for FilesystemTypedType.
const (
	Plain FilesystemTypedType = "plain"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	Buildroot ImageSBOMPipelinePurpose = "buildroot"
	Image     ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	Spdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding    ImageStatusValue = "building"
	ImageStatusValueFailure     ImageStatusValue = "failure"
	ImageStatusValuePending     ImageStatusValue = "pending"
	ImageStatusValueRegistering ImageStatusValue = "registering"
	ImageStatusValueSuccess     ImageStatusValue = "success"
	ImageStatusValueUploading   ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws                    ImageTypes = "aws"
	ImageTypesAwsHaRhui              ImageTypes = "aws-ha-rhui"
	ImageTypesAwsRhui                ImageTypes = "aws-rhui"
	ImageTypesAwsSapRhui             ImageTypes = "aws-sap-rhui"
	ImageTypesAzure                  ImageTypes = "azure"
	ImageTypesAzureEap7Rhui          ImageTypes = "azure-eap7-rhui"
	ImageTypesAzureRhui              ImageTypes = "azure-rhui"
	ImageTypesAzureSapRhui           ImageTypes = "azure-sap-rhui"
	ImageTypesEdgeCommit             ImageTypes = "edge-commit"
	ImageTypesEdgeContainer          ImageTypes = "edge-container"
	ImageTypesEdgeInstaller          ImageTypes = "edge-installer"
	ImageTypesGcp                    ImageTypes = "gcp"
	ImageTypesGcpRhui                ImageTypes = "gcp-rhui"
	ImageTypesGuestImage             ImageTypes = "guest-image"
	ImageTypesImageInstaller         ImageTypes = "image-installer"
	ImageTypesIotBootableContainer   ImageTypes = "iot-bootable-container"
	ImageTypesIotCommit              ImageTypes = "iot-commit"
	ImageTypesIotContainer           ImageTypes = "iot-container"
	ImageTypesIotInstaller           ImageTypes = "iot-installer"
	ImageTypesIotRawImage            ImageTypes = "iot-raw-image"
	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"
	ImageTypesLiveInstaller          ImageTypes = "live-installer"
	ImageTypesMinimalRaw             ImageTypes = "minimal-raw"
	ImageTypesOci                    ImageTypes = "oci"
	ImageTypesVsphere                ImageTypes = "vsphere"
	ImageTypesVsphereOva             ImageTypes = "vsphere-ova"
	ImageTypesWsl                    ImageTypes = "wsl"
)

// Defines values for LogicalVolumeFsType.
const (
	LogicalVolumeFsTypeExt4 LogicalVolumeFsType = "ext4"
	LogicalVolumeFsTypeVfat LogicalVolumeFsType = "vfat"
	LogicalVolumeFsTypeXfs  LogicalVolumeFsType = "xfs"
)

// Defines values for UploadStatusValue.
const (
	Failure UploadStatusValue = "failure"
	Pending UploadStatusValue = "pending"
	Running UploadStatusValue = "running"
	Success UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws              UploadTypes = "aws"
	UploadTypesAwsS3            UploadTypes = "aws.s3"
	UploadTypesAzure            UploadTypes = "azure"
	UploadTypesContainer        UploadTypes = "container"
	UploadTypesGcp              UploadTypes = "gcp"
	UploadTypesLocal            UploadTypes = "local"
	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"
	UploadTypesPulpOstree       UploadTypes = "pulp.ostree"
)

// Defines values for VolumeGroupType.
const (
	Lvm VolumeGroupType = "lvm"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// Public If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// HyperVGeneration Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// ImageName Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// ResourceGroup Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// SubscriptionId ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// TenantId ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// AzureUploadOptionsHyperVGeneration Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Containers Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// Distro The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro         *string   `json:"distro,omitempty"`
	EnabledModules *[]Module `json:"enabled_modules,omitempty"`

	// Groups Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// Modules An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// Version A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	Cacerts *CACertsCustomization `json:"cacerts,omitempty"`

	// Directories Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`
	Disk        *Disk        `json:"disk,omitempty"`

	// Fdo FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// Filesystem List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Fips Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewall Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// Group List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Hostname Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// InstallationDevice Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// PartitioningMode Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// Sshkey List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// User List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// BlueprintCustomizationsPartitioningMode Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// BlueprintFile A custom file to create in the final artifact.
type BlueprintFile struct {
	// Data Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group Group of the file as a gid or a group name
	Group *BlueprintFile_Group `json:"group,omitempty"`

	// Mode Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path Path to the file
	Path string `json:"path"`

	// User Owner of the file as a uid or a user name
	User *BlueprintFile_User `json:"user,omitempty"`
}

// BlueprintFileGroup0 defines model for .
type BlueprintFileGroup0 = string

// BlueprintFileGroup1 defines model for .
type BlueprintFileGroup1 = int64

// BlueprintFile_Group Group of the file as a gid or a group name
type BlueprintFile_Group struct {
	union json.RawMessage
}

// BlueprintFileUser0 defines model for .
type BlueprintFileUser0 = string

// BlueprintFileUser1 defines model for .
type BlueprintFileUser1 = int64

// BlueprintFile_User Owner of the file as a uid or a user name
type BlueprintFile_User struct {
	union json.RawMessage
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// Minsize size with data units
	Minsize    Minsize `json:"minsize"`
	Mountpoint string  `json:"mountpoint"`
}

// BlueprintFirewall Firewalld configuration
type BlueprintFirewall struct {
	// Ports List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Services Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// PolicyId Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *openapi_types.UUID `json:"policy_id,omitempty"`
	ProfileId string              `json:"profile_id"`
	Tailoring *OpenSCAPTailoring  `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// ModuleHotfixes Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Gid Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// Groups A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// Home The user's home directory
	Home *string `json:"home,omitempty"`

	// Key ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// Password If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Shell Login shell to use
	Shell *string `json:"shell,omitempty"`

	// Uid User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// BtrfsSubvolume defines model for BtrfsSubvolume.
type BtrfsSubvolume struct {
	// Mountpoint Mountpoint for the subvolume
	Mountpoint string `json:"mountpoint"`

	// Name The name of the subvolume, which defines the location (path) on the root volume
	Name string `json:"name"`
}

// BtrfsVolume defines model for BtrfsVolume.
type BtrfsVolume struct {
	// Minsize size with data units
	Minsize *Minsize `json:"minsize,omitempty"`

	// PartType The partition type GUID for GPT partitions. For DOS partitions, this field can be used to set the (2 hex digit) partition type. If not set, the type will be automatically set based on the mountpoint or the payload type.
	PartType   *string          `json:"part_type,omitempty"`
	Subvolumes []BtrfsSubvolume `json:"subvolumes"`
	Type       *BtrfsVolumeType `json:"type,omitempty"`
}

// BtrfsVolumeType defines model for BtrfsVolume.Type.
type BtrfsVolumeType string

// CACertsCustomization defines model for CACertsCustomization.
type CACertsCustomization struct {
	PemCerts []string `json:"pem_certs"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody struct {
	union json.RawMessage
}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	Href string             `json:"href"`
	Id   openapi_types.UUID `json:"id"`
	Kind string             `json:"kind"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	Href    string              `json:"href"`
	Id      string              `json:"id"`
	Kind    string              `json:"kind"`
	Options CloneStatus_Options `json:"options"`
	Status  UploadStatusValue   `json:"status"`
	Type    UploadTypes         `json:"type"`
}

// CloneStatus_Options defines model for CloneStatus.Options.
type CloneStatus_Options struct {
	union json.RawMessage
}

// ComposeDeleteStatus defines model for ComposeDeleteStatus.
type ComposeDeleteStatus = ObjectReference

// ComposeId defines model for ComposeId.
type ComposeId struct {
	Href string             `json:"href"`
	Id   openapi_types.UUID `json:"id"`
	Kind string             `json:"kind"`
}

// ComposeList defines model for ComposeList.
type ComposeList struct {
	Items []ComposeStatus `json:"items"`
	Kind  string          `json:"kind"`
	Page  int             `json:"page"`
	Size  int             `json:"size"`
	Total int             `json:"total"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	Href        string        `json:"href"`
	Id          string        `json:"id"`
	ImageBuilds []interface{} `json:"image_builds"`
	Kind        string        `json:"kind"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	Href      string        `json:"href"`
	Id        string        `json:"id"`
	Kind      string        `json:"kind"`
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`

	// OstreeCommit ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Packages Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
	Request  *ComposeRequest    `json:"request,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	Href string `json:"href"`
	Id   string `json:"id"`

	// Items The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
	Kind  string        `json:"kind"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	Href          string             `json:"href"`
	Id            string             `json:"id"`
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	Kind          string             `json:"kind"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Source Reference to the container to embed
	Source string `json:"source"`

	// TlsVerify Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// Url FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Cacerts    *CACertsCustomization `json:"cacerts,omitempty"`
	Containers *[]Container          `json:"containers,omitempty"`

	// CustomRepositories Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`
	Disk               *Disk               `json:"disk,omitempty"`
	EnabledModules     *[]Module           `json:"enabled_modules,omitempty"`

	// Fdo FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// Fips System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewall Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// Groups List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Hostname Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// InstallationDevice Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// PartitioningMode Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// PayloadRepositories Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// CustomizationsPartitioningMode Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// DepsolveRequest defines model for DepsolveRequest.
type DepsolveRequest struct {
	Architecture string        `json:"architecture"`
	Blueprint    Blueprint     `json:"blueprint"`
	Distribution string        `json:"distribution"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// DepsolveResponse defines model for DepsolveResponse.
type DepsolveResponse struct {
	// Packages Package list including NEVRA
	Packages []PackageMetadataCommon `json:"packages"`
}

// Directory A custom directory to create in the final artifact.
type Directory struct {
	// EnsureParents Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group Group of the directory as a group name or a gid
	Group *Directory_Group `json:"group,omitempty"`

	// Mode Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path Path to the directory
	Path string `json:"path"`

	// User Owner of the directory as a user name or a uid
	User *Directory_User `json:"user,omitempty"`
}

// DirectoryGroup0 defines model for .
type DirectoryGroup0 = string

// DirectoryGroup1 defines model for .
type DirectoryGroup1 = int64

// Directory_Group Group of the directory as a group name or a gid
type Directory_Group struct {
	union json.RawMessage
}

// DirectoryUser0 defines model for .
type DirectoryUser0 = string

// DirectoryUser1 defines model for .
type DirectoryUser1 = int64

// Directory_User Owner of the directory as a user name or a uid
type Directory_User struct {
	union json.RawMessage
}

// Disk defines model for Disk.
type Disk struct {
	// Minsize size with data units
	Minsize    *Minsize    `json:"minsize,omitempty"`
	Partitions []Partition `json:"partitions"`

	// Type Type of the partition table
	Type *DiskType `json:"type,omitempty"`
}

// DiskType Type of the partition table
type DiskType string

// DistributionList Map of distributions to their architecture.
type DistributionList map[string]map[string][]BlueprintRepository

// Error defines model for Error.
type Error struct {
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	Href        string       `json:"href"`
	Id          string       `json:"id"`
	Kind        string       `json:"kind"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	Items []Error `json:"items"`
	Kind  string  `json:"kind"`
	Page  int     `json:"page"`
	Size  int     `json:"size"`
	Total int     `json:"total"`
}

// FDO FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// FIPS System FIPS mode setup
type FIPS struct {
	// Enabled Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// File A custom file to create in the final artifact.
type File struct {
	// Data Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// EnsureParents Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group Group of the file as a gid or a group name
	Group *File_Group `json:"group,omitempty"`

	// Mode Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path Path to the file
	Path string `json:"path"`

	// User Owner of the file as a uid or a user name
	User *File_User `json:"user,omitempty"`
}

// FileGroup0 defines model for .
type FileGroup0 = string

// FileGroup1 defines model for .
type FileGroup1 = int64

// File_Group Group of the file as a gid or a group name
type File_Group struct {
	union json.RawMessage
}

// FileUser0 defines model for .
type FileUser0 = string

// FileUser1 defines model for .
type FileUser1 = int64

// File_User Owner of the file as a uid or a user name
type File_User struct {
	union json.RawMessage
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// MinSize size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// FilesystemTyped defines model for FilesystemTyped.
type FilesystemTyped struct {
	// FsType The filesystem type
	FsType *FilesystemTypedFsType `json:"fs_type,omitempty"`
	Label  *string                `json:"label,omitempty"`

	// Minsize size with data units
	Minsize    *Minsize `json:"minsize,omitempty"`
	Mountpoint string   `json:"mountpoint"`

	// PartType The partition type GUID for GPT partitions. For DOS partitions, this field can be used to set the (2 hex digit) partition type. If not set, the type will be automatically set based on the mountpoint or the payload type.
	PartType *string              `json:"part_type,omitempty"`
	Type     *FilesystemTypedType `json:"type,omitempty"`
}

// FilesystemTypedFsType The filesystem type
type FilesystemTypedFsType string

// FilesystemTypedType defines model for FilesystemTyped.Type.
type FilesystemTypedType string

// FirewallCustomization Firewalld configuration
type FirewallCustomization struct {
	// Ports List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Services Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// FirewallServices Firewalld services to enable or disable
type FirewallServices struct {
	// Disabled List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// Enabled List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// FirewallZones Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// Name name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// Sources List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Bucket Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// ImageName The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// Region The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// ShareWithAccounts List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Gid Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name Name of the group to create
	Name string `json:"name"`
}

// Ignition Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Url Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// UploadOptions Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// UploadTargets The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// PipelineName The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// PipelinePurpose The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// Sbom The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// SbomType The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// ImageSBOMPipelinePurpose The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// ImageSBOMSbomType The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Append Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions = map[string]interface{}

// LocalUploadStatus defines model for LocalUploadStatus.
type LocalUploadStatus struct {
	ArtifactPath string `json:"artifact_path"`
}

// Locale Locale configuration
type Locale struct {
	// Keyboard Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// Languages List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// LogicalVolume defines model for LogicalVolume.
type LogicalVolume struct {
	// FsType The filesystem type for the logical volume
	FsType *LogicalVolumeFsType `json:"fs_type,omitempty"`
	Label  *string              `json:"label,omitempty"`

	// Minsize size with data units
	Minsize *Minsize `json:"minsize,omitempty"`

	// Mountpoint Mountpoint for the logical volume
	Mountpoint string  `json:"mountpoint"`
	Name       *string `json:"name,omitempty"`
}

// LogicalVolumeFsType The filesystem type for the logical volume
type LogicalVolumeFsType string

// Module defines model for Module.
type Module struct {
	// Name Name of the module to enable.
	Name string `json:"name"`

	// Stream Stream to enable.
	Stream string `json:"stream"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions = map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// Contenturl A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Parent Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Rhsm Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// PolicyId Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *openapi_types.UUID `json:"policy_id,omitempty"`
	ProfileId string              `json:"profile_id"`
	Tailoring *OpenSCAPTailoring  `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Version Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageDetails defines model for PackageDetails.
type PackageDetails struct {
	Arch        string  `json:"arch"`
	Buildtime   *string `json:"buildtime,omitempty"`
	Description *string `json:"description,omitempty"`
	Epoch       *string `json:"epoch,omitempty"`
	License     *string `json:"license,omitempty"`
	Name        string  `json:"name"`
	Release     string  `json:"release"`
	Summary     *string `json:"summary,omitempty"`
	Url         *string `json:"url,omitempty"`
	Version     string  `json:"version"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Name Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch string `json:"arch"`

	// Checksum Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    string  `json:"sigmd5"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PackageMetadataCommon defines model for PackageMetadataCommon.
type PackageMetadataCommon struct {
	Arch string `json:"arch"`

	// Checksum Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// Partition defines model for Partition.
type Partition struct {
	union json.RawMessage
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// CheckRepoGpg Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// Gpgkey GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// ModuleHotfixes Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// PackageSets Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Rhsm Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Key Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User User to configure the ssh key for
	User string `json:"user"`
}

// SearchPackagesRequest defines model for SearchPackagesRequest.
type SearchPackagesRequest struct {
	Architecture string `json:"architecture"`
	Distribution string `json:"distribution"`

	// Packages Array of package names to search for. Supports * wildcards for
	// names, but not for versions.
	Packages     []string      `json:"packages"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// SearchPackagesResponse defines model for SearchPackagesResponse.
type SearchPackagesResponse struct {
	// Packages Detailed package information from DNF
	Packages []PackageDetails `json:"packages"`
}

// Services defines model for Services.
type Services struct {
	// Disabled List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// Enabled List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// Masked List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	AutoEnableYumPlugins *bool `json:"auto_enable_yum_plugins,omitempty"`
	ManageRepos          *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`

	// InsightsClientProxy Optional value to set proxy option when registering the system to Insights
	InsightsClientProxy *string `json:"insights_client_proxy,omitempty"`
	Organization        string  `json:"organization"`

	// Rhc Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`

	// TemplateName Optional value to register with a template when using rhc to register the system with Insights.
	TemplateName *string `json:"template_name,omitempty"`

	// TemplateUuid Optional value to register with a template when registering the system with Insights.
	TemplateUuid *string `json:"template_uuid,omitempty"`
}

// Timezone Timezone configuration
type Timezone struct {
	// Ntpservers List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Timezone Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// UploadOptions Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions struct {
	union json.RawMessage
}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options UploadStatus_Options `json:"options"`
	Status  UploadStatusValue    `json:"status"`
	Type    UploadTypes          `json:"type"`
}

// UploadStatus_Options defines model for UploadStatus.Options.
type UploadStatus_Options struct {
	union json.RawMessage
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// UploadOptions Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// Password If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// VolumeGroup defines model for VolumeGroup.
type VolumeGroup struct {
	LogicalVolumes []LogicalVolume `json:"logical_volumes"`

	// Minsize size with data units
	Minsize *Minsize `json:"minsize,omitempty"`

	// Name Volume group name (will be automatically generated if omitted)
	Name *string `json:"name,omitempty"`

	// PartType The partition type GUID for GPT partitions. For DOS partitions, this field can be used to set the (2 hex digit) partition type. If not set, the type will be automatically set based on the mountpoint or the payload type.
	PartType *string          `json:"part_type,omitempty"`
	Type     *VolumeGroupType `json:"type,omitempty"`
}

// VolumeGroupType defines model for VolumeGroup.Type.
type VolumeGroupType string

// Minsize size with data units
type Minsize = string

// Page defines model for page.
type Page = string

// Size defines model for size.
type Size = string

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page Page index
	Page *Page `form:"page,omitempty" json:"page,omitempty"`

	// Size Number of items in each page
	Size *Size `form:"size,omitempty" json:"size,omitempty"`
}

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody = ComposeRequest

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody = CloneComposeBody

// PostDepsolveBlueprintJSONRequestBody defines body for PostDepsolveBlueprint for application/json ContentType.
type PostDepsolveBlueprintJSONRequestBody = DepsolveRequest

// PostSearchPackagesJSONRequestBody defines body for PostSearchPackages for application/json ContentType.
type PostSearchPackagesJSONRequestBody = SearchPackagesRequest

// AsBlueprintFileGroup0 returns the union data inside the BlueprintFile_Group as a BlueprintFileGroup0
func (t BlueprintFile_Group) AsBlueprintFileGroup0() (BlueprintFileGroup0, error) {
	var body BlueprintFileGroup0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromBlueprintFileGroup0 overwrites any union data inside the BlueprintFile_Group as the provided BlueprintFileGroup0
func (t *BlueprintFile_Group) FromBlueprintFileGroup0(v BlueprintFileGroup0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeBlueprintFileGroup0 performs a merge with any union data inside the BlueprintFile_Group, using the provided BlueprintFileGroup0
func (t *BlueprintFile_Group) MergeBlueprintFileGroup0(v BlueprintFileGroup0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsBlueprintFileGroup1 returns the union data inside the BlueprintFile_Group as a BlueprintFileGroup1
func (t BlueprintFile_Group) AsBlueprintFileGroup1() (BlueprintFileGroup1, error) {
	var body BlueprintFileGroup1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromBlueprintFileGroup1 overwrites any union data inside the BlueprintFile_Group as the provided BlueprintFileGroup1
func (t *BlueprintFile_Group) FromBlueprintFileGroup1(v BlueprintFileGroup1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeBlueprintFileGroup1 performs a merge with any union data inside the BlueprintFile_Group, using the provided BlueprintFileGroup1
func (t *BlueprintFile_Group) MergeBlueprintFileGroup1(v BlueprintFileGroup1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t BlueprintFile_Group) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *BlueprintFile_Group) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsBlueprintFileUser0 returns the union data inside the BlueprintFile_User as a BlueprintFileUser0
func (t BlueprintFile_User) AsBlueprintFileUser0() (BlueprintFileUser0, error) {
	var body BlueprintFileUser0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromBlueprintFileUser0 overwrites any union data inside the BlueprintFile_User as the provided BlueprintFileUser0
func (t *BlueprintFile_User) FromBlueprintFileUser0(v BlueprintFileUser0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeBlueprintFileUser0 performs a merge with any union data inside the BlueprintFile_User, using the provided BlueprintFileUser0
func (t *BlueprintFile_User) MergeBlueprintFileUser0(v BlueprintFileUser0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsBlueprintFileUser1 returns the union data inside the BlueprintFile_User as a BlueprintFileUser1
func (t BlueprintFile_User) AsBlueprintFileUser1() (BlueprintFileUser1, error) {
	var body BlueprintFileUser1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromBlueprintFileUser1 overwrites any union data inside the BlueprintFile_User as the provided BlueprintFileUser1
func (t *BlueprintFile_User) FromBlueprintFileUser1(v BlueprintFileUser1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeBlueprintFileUser1 performs a merge with any union data inside the BlueprintFile_User, using the provided BlueprintFileUser1
func (t *BlueprintFile_User) MergeBlueprintFileUser1(v BlueprintFileUser1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t BlueprintFile_User) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *BlueprintFile_User) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsAWSEC2CloneCompose returns the union data inside the CloneComposeBody as a AWSEC2CloneCompose
func (t CloneComposeBody) AsAWSEC2CloneCompose() (AWSEC2CloneCompose, error) {
	var body AWSEC2CloneCompose
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAWSEC2CloneCompose overwrites any union data inside the CloneComposeBody as the provided AWSEC2CloneCompose
func (t *CloneComposeBody) FromAWSEC2CloneCompose(v AWSEC2CloneCompose) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAWSEC2CloneCompose performs a merge with any union data inside the CloneComposeBody, using the provided AWSEC2CloneCompose
func (t *CloneComposeBody) MergeAWSEC2CloneCompose(v AWSEC2CloneCompose) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t CloneComposeBody) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *CloneComposeBody) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsAWSEC2UploadStatus returns the union data inside the CloneStatus_Options as a AWSEC2UploadStatus
func (t CloneStatus_Options) AsAWSEC2UploadStatus() (AWSEC2UploadStatus, error) {
	var body AWSEC2UploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAWSEC2UploadStatus overwrites any union data inside the CloneStatus_Options as the provided AWSEC2UploadStatus
func (t *CloneStatus_Options) FromAWSEC2UploadStatus(v AWSEC2UploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAWSEC2UploadStatus performs a merge with any union data inside the CloneStatus_Options, using the provided AWSEC2UploadStatus
func (t *CloneStatus_Options) MergeAWSEC2UploadStatus(v AWSEC2UploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsAWSS3UploadStatus returns the union data inside the CloneStatus_Options as a AWSS3UploadStatus
func (t CloneStatus_Options) AsAWSS3UploadStatus() (AWSS3UploadStatus, error) {
	var body AWSS3UploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAWSS3UploadStatus overwrites any union data inside the CloneStatus_Options as the provided AWSS3UploadStatus
func (t *CloneStatus_Options) FromAWSS3UploadStatus(v AWSS3UploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAWSS3UploadStatus performs a merge with any union data inside the CloneStatus_Options, using the provided AWSS3UploadStatus
func (t *CloneStatus_Options) MergeAWSS3UploadStatus(v AWSS3UploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsGCPUploadStatus returns the union data inside the CloneStatus_Options as a GCPUploadStatus
func (t CloneStatus_Options) AsGCPUploadStatus() (GCPUploadStatus, error) {
	var body GCPUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromGCPUploadStatus overwrites any union data inside the CloneStatus_Options as the provided GCPUploadStatus
func (t *CloneStatus_Options) FromGCPUploadStatus(v GCPUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeGCPUploadStatus performs a merge with any union data inside the CloneStatus_Options, using the provided GCPUploadStatus
func (t *CloneStatus_Options) MergeGCPUploadStatus(v GCPUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsAzureUploadStatus returns the union data inside the CloneStatus_Options as a AzureUploadStatus
func (t CloneStatus_Options) AsAzureUploadStatus() (AzureUploadStatus, error) {
	var body AzureUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAzureUploadStatus overwrites any union data inside the CloneStatus_Options as the provided AzureUploadStatus
func (t *CloneStatus_Options) FromAzureUploadStatus(v AzureUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAzureUploadStatus performs a merge with any union data inside the CloneStatus_Options, using the provided AzureUploadStatus
func (t *CloneStatus_Options) MergeAzureUploadStatus(v AzureUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsContainerUploadStatus returns the union data inside the CloneStatus_Options as a ContainerUploadStatus
func (t CloneStatus_Options) AsContainerUploadStatus() (ContainerUploadStatus, error) {
	var body ContainerUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromContainerUploadStatus overwrites any union data inside the CloneStatus_Options as the provided ContainerUploadStatus
func (t *CloneStatus_Options) FromContainerUploadStatus(v ContainerUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeContainerUploadStatus performs a merge with any union data inside the CloneStatus_Options, using the provided ContainerUploadStatus
func (t *CloneStatus_Options) MergeContainerUploadStatus(v ContainerUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsOCIUploadStatus returns the union data inside the CloneStatus_Options as a OCIUploadStatus
func (t CloneStatus_Options) AsOCIUploadStatus() (OCIUploadStatus, error) {
	var body OCIUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromOCIUploadStatus overwrites any union data inside the CloneStatus_Options as the provided OCIUploadStatus
func (t *CloneStatus_Options) FromOCIUploadStatus(v OCIUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeOCIUploadStatus performs a merge with any union data inside the CloneStatus_Options, using the provided OCIUploadStatus
func (t *CloneStatus_Options) MergeOCIUploadStatus(v OCIUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsPulpOSTreeUploadStatus returns the union data inside the CloneStatus_Options as a PulpOSTreeUploadStatus
func (t CloneStatus_Options) AsPulpOSTreeUploadStatus() (PulpOSTreeUploadStatus, error) {
	var body PulpOSTreeUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromPulpOSTreeUploadStatus overwrites any union data inside the CloneStatus_Options as the provided PulpOSTreeUploadStatus
func (t *CloneStatus_Options) FromPulpOSTreeUploadStatus(v PulpOSTreeUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergePulpOSTreeUploadStatus performs a merge with any union data inside the CloneStatus_Options, using the provided PulpOSTreeUploadStatus
func (t *CloneStatus_Options) MergePulpOSTreeUploadStatus(v PulpOSTreeUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsLocalUploadStatus returns the union data inside the CloneStatus_Options as a LocalUploadStatus
func (t CloneStatus_Options) AsLocalUploadStatus() (LocalUploadStatus, error) {
	var body LocalUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromLocalUploadStatus overwrites any union data inside the CloneStatus_Options as the provided LocalUploadStatus
func (t *CloneStatus_Options) FromLocalUploadStatus(v LocalUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeLocalUploadStatus performs a merge with any union data inside the CloneStatus_Options, using the provided LocalUploadStatus
func (t *CloneStatus_Options) MergeLocalUploadStatus(v LocalUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t CloneStatus_Options) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *CloneStatus_Options) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsDirectoryGroup0 returns the union data inside the Directory_Group as a DirectoryGroup0
func (t Directory_Group) AsDirectoryGroup0() (DirectoryGroup0, error) {
	var body DirectoryGroup0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDirectoryGroup0 overwrites any union data inside the Directory_Group as the provided DirectoryGroup0
func (t *Directory_Group) FromDirectoryGroup0(v DirectoryGroup0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDirectoryGroup0 performs a merge with any union data inside the Directory_Group, using the provided DirectoryGroup0
func (t *Directory_Group) MergeDirectoryGroup0(v DirectoryGroup0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsDirectoryGroup1 returns the union data inside the Directory_Group as a DirectoryGroup1
func (t Directory_Group) AsDirectoryGroup1() (DirectoryGroup1, error) {
	var body DirectoryGroup1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDirectoryGroup1 overwrites any union data inside the Directory_Group as the provided DirectoryGroup1
func (t *Directory_Group) FromDirectoryGroup1(v DirectoryGroup1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDirectoryGroup1 performs a merge with any union data inside the Directory_Group, using the provided DirectoryGroup1
func (t *Directory_Group) MergeDirectoryGroup1(v DirectoryGroup1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t Directory_Group) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Directory_Group) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsDirectoryUser0 returns the union data inside the Directory_User as a DirectoryUser0
func (t Directory_User) AsDirectoryUser0() (DirectoryUser0, error) {
	var body DirectoryUser0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDirectoryUser0 overwrites any union data inside the Directory_User as the provided DirectoryUser0
func (t *Directory_User) FromDirectoryUser0(v DirectoryUser0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDirectoryUser0 performs a merge with any union data inside the Directory_User, using the provided DirectoryUser0
func (t *Directory_User) MergeDirectoryUser0(v DirectoryUser0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsDirectoryUser1 returns the union data inside the Directory_User as a DirectoryUser1
func (t Directory_User) AsDirectoryUser1() (DirectoryUser1, error) {
	var body DirectoryUser1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDirectoryUser1 overwrites any union data inside the Directory_User as the provided DirectoryUser1
func (t *Directory_User) FromDirectoryUser1(v DirectoryUser1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDirectoryUser1 performs a merge with any union data inside the Directory_User, using the provided DirectoryUser1
func (t *Directory_User) MergeDirectoryUser1(v DirectoryUser1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t Directory_User) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Directory_User) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsFileGroup0 returns the union data inside the File_Group as a FileGroup0
func (t File_Group) AsFileGroup0() (FileGroup0, error) {
	var body FileGroup0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFileGroup0 overwrites any union data inside the File_Group as the provided FileGroup0
func (t *File_Group) FromFileGroup0(v FileGroup0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFileGroup0 performs a merge with any union data inside the File_Group, using the provided FileGroup0
func (t *File_Group) MergeFileGroup0(v FileGroup0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFileGroup1 returns the union data inside the File_Group as a FileGroup1
func (t File_Group) AsFileGroup1() (FileGroup1, error) {
	var body FileGroup1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFileGroup1 overwrites any union data inside the File_Group as the provided FileGroup1
func (t *File_Group) FromFileGroup1(v FileGroup1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFileGroup1 performs a merge with any union data inside the File_Group, using the provided FileGroup1
func (t *File_Group) MergeFileGroup1(v FileGroup1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t File_Group) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *File_Group) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsFileUser0 returns the union data inside the File_User as a FileUser0
func (t File_User) AsFileUser0() (FileUser0, error) {
	var body FileUser0
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFileUser0 overwrites any union data inside the File_User as the provided FileUser0
func (t *File_User) FromFileUser0(v FileUser0) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFileUser0 performs a merge with any union data inside the File_User, using the provided FileUser0
func (t *File_User) MergeFileUser0(v FileUser0) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFileUser1 returns the union data inside the File_User as a FileUser1
func (t File_User) AsFileUser1() (FileUser1, error) {
	var body FileUser1
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFileUser1 overwrites any union data inside the File_User as the provided FileUser1
func (t *File_User) FromFileUser1(v FileUser1) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFileUser1 performs a merge with any union data inside the File_User, using the provided FileUser1
func (t *File_User) MergeFileUser1(v FileUser1) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t File_User) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *File_User) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsFilesystemTyped returns the union data inside the Partition as a FilesystemTyped
func (t Partition) AsFilesystemTyped() (FilesystemTyped, error) {
	var body FilesystemTyped
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFilesystemTyped overwrites any union data inside the Partition as the provided FilesystemTyped
func (t *Partition) FromFilesystemTyped(v FilesystemTyped) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFilesystemTyped performs a merge with any union data inside the Partition, using the provided FilesystemTyped
func (t *Partition) MergeFilesystemTyped(v FilesystemTyped) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsBtrfsVolume returns the union data inside the Partition as a BtrfsVolume
func (t Partition) AsBtrfsVolume() (BtrfsVolume, error) {
	var body BtrfsVolume
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromBtrfsVolume overwrites any union data inside the Partition as the provided BtrfsVolume
func (t *Partition) FromBtrfsVolume(v BtrfsVolume) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeBtrfsVolume performs a merge with any union data inside the Partition, using the provided BtrfsVolume
func (t *Partition) MergeBtrfsVolume(v BtrfsVolume) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsVolumeGroup returns the union data inside the Partition as a VolumeGroup
func (t Partition) AsVolumeGroup() (VolumeGroup, error) {
	var body VolumeGroup
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromVolumeGroup overwrites any union data inside the Partition as the provided VolumeGroup
func (t *Partition) FromVolumeGroup(v VolumeGroup) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeVolumeGroup performs a merge with any union data inside the Partition, using the provided VolumeGroup
func (t *Partition) MergeVolumeGroup(v VolumeGroup) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t Partition) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Partition) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsAWSEC2UploadOptions returns the union data inside the UploadOptions as a AWSEC2UploadOptions
func (t UploadOptions) AsAWSEC2UploadOptions() (AWSEC2UploadOptions, error) {
	var body AWSEC2UploadOptions
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAWSEC2UploadOptions overwrites any union data inside the UploadOptions as the provided AWSEC2UploadOptions
func (t *UploadOptions) FromAWSEC2UploadOptions(v AWSEC2UploadOptions) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAWSEC2UploadOptions performs a merge with any union data inside the UploadOptions, using the provided AWSEC2UploadOptions
func (t *UploadOptions) MergeAWSEC2UploadOptions(v AWSEC2UploadOptions) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsAWSS3UploadOptions returns the union data inside the UploadOptions as a AWSS3UploadOptions
func (t UploadOptions) AsAWSS3UploadOptions() (AWSS3UploadOptions, error) {
	var body AWSS3UploadOptions
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAWSS3UploadOptions overwrites any union data inside the UploadOptions as the provided AWSS3UploadOptions
func (t *UploadOptions) FromAWSS3UploadOptions(v AWSS3UploadOptions) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAWSS3UploadOptions performs a merge with any union data inside the UploadOptions, using the provided AWSS3UploadOptions
func (t *UploadOptions) MergeAWSS3UploadOptions(v AWSS3UploadOptions) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsGCPUploadOptions returns the union data inside the UploadOptions as a GCPUploadOptions
func (t UploadOptions) AsGCPUploadOptions() (GCPUploadOptions, error) {
	var body GCPUploadOptions
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromGCPUploadOptions overwrites any union data inside the UploadOptions as the provided GCPUploadOptions
func (t *UploadOptions) FromGCPUploadOptions(v GCPUploadOptions) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeGCPUploadOptions performs a merge with any union data inside the UploadOptions, using the provided GCPUploadOptions
func (t *UploadOptions) MergeGCPUploadOptions(v GCPUploadOptions) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsAzureUploadOptions returns the union data inside the UploadOptions as a AzureUploadOptions
func (t UploadOptions) AsAzureUploadOptions() (AzureUploadOptions, error) {
	var body AzureUploadOptions
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAzureUploadOptions overwrites any union data inside the UploadOptions as the provided AzureUploadOptions
func (t *UploadOptions) FromAzureUploadOptions(v AzureUploadOptions) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAzureUploadOptions performs a merge with any union data inside the UploadOptions, using the provided AzureUploadOptions
func (t *UploadOptions) MergeAzureUploadOptions(v AzureUploadOptions) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsContainerUploadOptions returns the union data inside the UploadOptions as a ContainerUploadOptions
func (t UploadOptions) AsContainerUploadOptions() (ContainerUploadOptions, error) {
	var body ContainerUploadOptions
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromContainerUploadOptions overwrites any union data inside the UploadOptions as the provided ContainerUploadOptions
func (t *UploadOptions) FromContainerUploadOptions(v ContainerUploadOptions) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeContainerUploadOptions performs a merge with any union data inside the UploadOptions, using the provided ContainerUploadOptions
func (t *UploadOptions) MergeContainerUploadOptions(v ContainerUploadOptions) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsLocalUploadOptions returns the union data inside the UploadOptions as a LocalUploadOptions
func (t UploadOptions) AsLocalUploadOptions() (LocalUploadOptions, error) {
	var body LocalUploadOptions
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromLocalUploadOptions overwrites any union data inside the UploadOptions as the provided LocalUploadOptions
func (t *UploadOptions) FromLocalUploadOptions(v LocalUploadOptions) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeLocalUploadOptions performs a merge with any union data inside the UploadOptions, using the provided LocalUploadOptions
func (t *UploadOptions) MergeLocalUploadOptions(v LocalUploadOptions) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsOCIUploadOptions returns the union data inside the UploadOptions as a OCIUploadOptions
func (t UploadOptions) AsOCIUploadOptions() (OCIUploadOptions, error) {
	var body OCIUploadOptions
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromOCIUploadOptions overwrites any union data inside the UploadOptions as the provided OCIUploadOptions
func (t *UploadOptions) FromOCIUploadOptions(v OCIUploadOptions) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeOCIUploadOptions performs a merge with any union data inside the UploadOptions, using the provided OCIUploadOptions
func (t *UploadOptions) MergeOCIUploadOptions(v OCIUploadOptions) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsPulpOSTreeUploadOptions returns the union data inside the UploadOptions as a PulpOSTreeUploadOptions
func (t UploadOptions) AsPulpOSTreeUploadOptions() (PulpOSTreeUploadOptions, error) {
	var body PulpOSTreeUploadOptions
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromPulpOSTreeUploadOptions overwrites any union data inside the UploadOptions as the provided PulpOSTreeUploadOptions
func (t *UploadOptions) FromPulpOSTreeUploadOptions(v PulpOSTreeUploadOptions) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergePulpOSTreeUploadOptions performs a merge with any union data inside the UploadOptions, using the provided PulpOSTreeUploadOptions
func (t *UploadOptions) MergePulpOSTreeUploadOptions(v PulpOSTreeUploadOptions) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t UploadOptions) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *UploadOptions) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsAWSEC2UploadStatus returns the union data inside the UploadStatus_Options as a AWSEC2UploadStatus
func (t UploadStatus_Options) AsAWSEC2UploadStatus() (AWSEC2UploadStatus, error) {
	var body AWSEC2UploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAWSEC2UploadStatus overwrites any union data inside the UploadStatus_Options as the provided AWSEC2UploadStatus
func (t *UploadStatus_Options) FromAWSEC2UploadStatus(v AWSEC2UploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAWSEC2UploadStatus performs a merge with any union data inside the UploadStatus_Options, using the provided AWSEC2UploadStatus
func (t *UploadStatus_Options) MergeAWSEC2UploadStatus(v AWSEC2UploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsAWSS3UploadStatus returns the union data inside the UploadStatus_Options as a AWSS3UploadStatus
func (t UploadStatus_Options) AsAWSS3UploadStatus() (AWSS3UploadStatus, error) {
	var body AWSS3UploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAWSS3UploadStatus overwrites any union data inside the UploadStatus_Options as the provided AWSS3UploadStatus
func (t *UploadStatus_Options) FromAWSS3UploadStatus(v AWSS3UploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAWSS3UploadStatus performs a merge with any union data inside the UploadStatus_Options, using the provided AWSS3UploadStatus
func (t *UploadStatus_Options) MergeAWSS3UploadStatus(v AWSS3UploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsGCPUploadStatus returns the union data inside the UploadStatus_Options as a GCPUploadStatus
func (t UploadStatus_Options) AsGCPUploadStatus() (GCPUploadStatus, error) {
	var body GCPUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromGCPUploadStatus overwrites any union data inside the UploadStatus_Options as the provided GCPUploadStatus
func (t *UploadStatus_Options) FromGCPUploadStatus(v GCPUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeGCPUploadStatus performs a merge with any union data inside the UploadStatus_Options, using the provided GCPUploadStatus
func (t *UploadStatus_Options) MergeGCPUploadStatus(v GCPUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsAzureUploadStatus returns the union data inside the UploadStatus_Options as a AzureUploadStatus
func (t UploadStatus_Options) AsAzureUploadStatus() (AzureUploadStatus, error) {
	var body AzureUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromAzureUploadStatus overwrites any union data inside the UploadStatus_Options as the provided AzureUploadStatus
func (t *UploadStatus_Options) FromAzureUploadStatus(v AzureUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeAzureUploadStatus performs a merge with any union data inside the UploadStatus_Options, using the provided AzureUploadStatus
func (t *UploadStatus_Options) MergeAzureUploadStatus(v AzureUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsContainerUploadStatus returns the union data inside the UploadStatus_Options as a ContainerUploadStatus
func (t UploadStatus_Options) AsContainerUploadStatus() (ContainerUploadStatus, error) {
	var body ContainerUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromContainerUploadStatus overwrites any union data inside the UploadStatus_Options as the provided ContainerUploadStatus
func (t *UploadStatus_Options) FromContainerUploadStatus(v ContainerUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeContainerUploadStatus performs a merge with any union data inside the UploadStatus_Options, using the provided ContainerUploadStatus
func (t *UploadStatus_Options) MergeContainerUploadStatus(v ContainerUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsOCIUploadStatus returns the union data inside the UploadStatus_Options as a OCIUploadStatus
func (t UploadStatus_Options) AsOCIUploadStatus() (OCIUploadStatus, error) {
	var body OCIUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromOCIUploadStatus overwrites any union data inside the UploadStatus_Options as the provided OCIUploadStatus
func (t *UploadStatus_Options) FromOCIUploadStatus(v OCIUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeOCIUploadStatus performs a merge with any union data inside the UploadStatus_Options, using the provided OCIUploadStatus
func (t *UploadStatus_Options) MergeOCIUploadStatus(v OCIUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsPulpOSTreeUploadStatus returns the union data inside the UploadStatus_Options as a PulpOSTreeUploadStatus
func (t UploadStatus_Options) AsPulpOSTreeUploadStatus() (PulpOSTreeUploadStatus, error) {
	var body PulpOSTreeUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromPulpOSTreeUploadStatus overwrites any union data inside the UploadStatus_Options as the provided PulpOSTreeUploadStatus
func (t *UploadStatus_Options) FromPulpOSTreeUploadStatus(v PulpOSTreeUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergePulpOSTreeUploadStatus performs a merge with any union data inside the UploadStatus_Options, using the provided PulpOSTreeUploadStatus
func (t *UploadStatus_Options) MergePulpOSTreeUploadStatus(v PulpOSTreeUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsLocalUploadStatus returns the union data inside the UploadStatus_Options as a LocalUploadStatus
func (t UploadStatus_Options) AsLocalUploadStatus() (LocalUploadStatus, error) {
	var body LocalUploadStatus
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromLocalUploadStatus overwrites any union data inside the UploadStatus_Options as the provided LocalUploadStatus
func (t *UploadStatus_Options) FromLocalUploadStatus(v LocalUploadStatus) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeLocalUploadStatus performs a merge with any union data inside the UploadStatus_Options, using the provided LocalUploadStatus
func (t *UploadStatus_Options) MergeLocalUploadStatus(v LocalUploadStatus) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t UploadStatus_Options) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *UploadStatus_Options) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id openapi_types.UUID) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The list of composes
	// (GET /composes/)
	GetComposeList(ctx echo.Context) error
	// Delete a compose
	// (DELETE /composes/delete/{id})
	DeleteCompose(ctx echo.Context, id openapi_types.UUID) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id openapi_types.UUID) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id openapi_types.UUID) error
	// Download the artifact for a compose.
	// (GET /composes/{id}/download)
	GetComposeDownload(ctx echo.Context, id openapi_types.UUID) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id openapi_types.UUID) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id openapi_types.UUID) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id openapi_types.UUID) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id openapi_types.UUID) error
	// Depsolve one or more blueprints
	// (POST /depsolve/blueprint)
	PostDepsolveBlueprint(ctx echo.Context) error
	// Get all of the supported distribution repository details
	// (GET /distributions)
	GetDistributionList(ctx echo.Context) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
	// Search for detailed information on a list of package names
	// (POST /search/packages)
	PostSearchPackages(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeList converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetComposeList(ctx)
	return err
}

// DeleteCompose converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.DeleteCompose(ctx, id)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeDownload converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeDownload(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetComposeDownload(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id openapi_types.UUID

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// PostDepsolveBlueprint converts echo context to params.
func (w *ServerInterfaceWrapper) PostDepsolveBlueprint(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.PostDepsolveBlueprint(ctx)
	return err
}

// GetDistributionList converts echo context to params.
func (w *ServerInterfaceWrapper) GetDistributionList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetDistributionList(ctx)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithOptions("simple", "id", ctx.Param("id"), &id, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// PostSearchPackages converts echo context to params.
func (w *ServerInterfaceWrapper) PostSearchPackages(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{})

	// Invoke the callback with all the unmarshaled arguments
	err = w.Handler.PostSearchPackages(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/", wrapper.GetComposeList)
	router.DELETE(baseURL+"/composes/delete/:id", wrapper.DeleteCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/download", wrapper.GetComposeDownload)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.POST(baseURL+"/depsolve/blueprint", wrapper.PostDepsolveBlueprint)
	router.GET(baseURL+"/distributions", wrapper.GetDistributionList)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)
	router.POST(baseURL+"/search/packages", wrapper.PostSearchPackages)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXPbOLL4V0HpN1WZvOiyDltO1dZ7snzJdywfsVcpL0RCEiwSYABQsjwv3/1XOEiR",
	"Eqgjx+zMPv+xO7GIo9HobnQ3uht/5BzqB5QgInju4x+5ADLoI4GY+WuA5H9dxB2GA4EpyX3MXcEBApi4",
	"6CWXz6EX6AceSjUfQy9EuY+5rdy3b/kcln2+hohNc/kcgb78olrmc9wZIh/KLmIayN+5YJgMVDeOXy1z",
	"X4R+DzFA+wAL5HOACUDQGQIzYBKaaIAYmnI5Ex7Vdhk836KPaujmfeegVWl5lKCWRB9XE0HXxRJM6F0x",
	"GiAmsASkDz2O8rkg8dMfOYYGaj0LE+VzfAgZeppgMXyCjkNDszFmZbmP/8xtVaq1+vZOY7e8Vcl9yecU",
	"JqxjmR8gY3Cq1s7Q1xAz5MphDAxf4ma094wcIfvp9d0GHoXupUI9/+4FxoDnUFiYIC4KW7n8n7nsfI4T",
	"GPAhFU96t5Mw+dNC9HURKjvC7LCuQmNHQBFqLkkhCvo4DRH0caHsNKrlnd3qzk69vlt3az0bxjZE8dxi",
	"5Lz5FTTQqf4ICQRhz8OOZuE+DD0Rt0uzdLsPOBJAUKA+g9/FEAHTBSjmfZ8HEHiUDPKA9vohd6BALri9",
	"PusSzAFDImQEuUXQFhyglwAzKIcGPh4MBeghwCkliAExhAT0KQNUDBEDoVpblwjIBkjwYpd0yQwWwUIk",
	"p+VDygRicjaQmAxA4nYJTk+IOZCwc+gjALmaSv6dnA7MZpttUY9SD0Hy45u63nZmkWLIPLsoTk4hG1nH",
	"fw0Z+hFyGU4DxJ7GTwNEkMZninRyd3L5acppDSnlSOH47hy0fXkuHcth7sBslDxwcb+PGCIC9BEUIUMc",
	"UAIUwADK/40h9mDPQ13iogARF5OBbCHHXRhObxwioS+xoYC6qyQwMuNPLOGJRc7cMSZJhPbVFJowkAtU",
	"B0nFwA+5ItyQ4K+hPGtVwwEeIwIY4jRkDgIDRsOgqGhWTiKpj/pYSNboM+qrLnLnEBeSkBkkLvUBJQj0",
	"IEeuXCEEt7ftfYB5l5gVItcsMCkhFWA2EeRRJ7FTyQWemS/RIgNGx1guMgL/SYGfB5MhYnoL1SyS30LP",
	"VYuP8AKJ7DbAXCCm4DumE8miHuYCQM8DERj8Y5cMhQj4x1LJpQ4v+thhlNO+KDrULyFSCHnJ8XAJyr0v",
	"Gdn932OMJv9QPxUcDxc8KBAX/w++RsL9SU70FE/yTqFcQhz9JFFPqAA8QA7uY+TmARbyRxe5oZPakAw8",
	"zCNd8jsKJX/YJX+y73LqSpPLGuieB+WGhg4k12aYIzWj7fwOezEIT9hdBKq9L0FKNvsOYGqo7jZ6FacA",
	"e5VaoVbbqhZ2y069sL1VqZa3UaO8iyo26AQikIglcEkgdKP1oDIk2MfEVXutOVTLlCvKBPTWocWIDgUe",
	"o4KLGXIEZdNSPyQu9BER0OMLXwtDOikIWpBTFzTIc0iqOzuoX+9tF7acar9Qc2G5ALcrlUK5V94uV6q7",
	"7o67s/IomWFscW8XKHDFgZB14KQl5DoiZw7IxAA2EPa8EAUME7HhUeRQIiAmxgiaO3Oib5o6uKQC5Pek",
	"+CZSbRgiSRTQA5CJPnSkVhkrqr8x1M99zP2/0szmKhmrohSPa1NgnZAL6uNXGB+sy4aKl91Kd/s2d35a",
	"NGcXc8Ho4qpvpEomv+FeqFhXUBByFKs4jraCiqDdBx7qC4D8QEzVpyHlokv0wGCCPU9xEl/k7T5yKYOF",
	"6q6NgRGRB7T75FM3NPbdWmg9V+1tOFWUy23WrTOSbK+/y4X25AnMBfQ85K67nWYULS4tsyfWkZ6+SQD0",
	"sNEeAz0Kz0u9U1KHq37uQWc0gczlCu9QwB72sJgqfG4CnQ2wiBsXdiCCJRNjP4orGzRjxLhVv2gCjvwx",
	"YsC0AEQ5BlIEtVPcKe6UVwqR1eKjtcB+mwgT6CAmVvN/syWbpabSHKnlPrZhfn/2USLfYQiKWF2MxRDe",
	"RA5FQ05t2+FiPlo9AB/Jtn2Xrmp6uH+pWmIrJxzKn3/WsuK9lKPalqaAmHKBfIsyKxVN2gezNsCXimFA",
	"MREJEL8LGDOpFSSbfDpQkhActq86wKcuspqRfczQBHreBpCYDpFkzMbCTDButupMWShPCLuZ1KKkjwfK",
	"YouOEtXQZm0NCI6OtWVQtKN2yhOoJJXitScXjbGzwlRLdgC6Qx44IZPGpTcFlHhTebT1Qy8+GZE7QAWO",
	"/cBTlkEhko4MyCXMHYElF41L3IXWBUYdV64wbvgtnxshRtBKMjjVrYxF56FV7c90q2/5HA0Q4Q4M1ia0",
	"ywCRTqt5pY8UJtRmYDJ4UrScsvhhKGjBG/sLdn8HecgRYCh1cK2YjIyuHukX8cjILYJ30UDv9HepuDA4",
	"ASHxEOddIpTCDxlSxjFlwKcMpTgcS1sFO0PgQI6kvh+Pc3Z3XgTv1NjQm8Ap75KQIy5/zwMk7fXJECnB",
	"ZaYgFKAXwWBy/CJ4x+DkHVA9JWQx+LxLbINkwJn2TTA4yeVzGn8xKr9YzcmAcpx1xlwnvkqmnzAskPxH",
	"CQmnNA39oupfdEtpCW28GRdUIIliKOQ3HiFBKBUQQAF6IfZcILCPiusrMDE5xdBZzys25P6qoa6PO+cL",
	"py4LVve7WuzGEZMyYSX4naid7MOHIzTNFrecD8EITfm6qOl0jk+RFRsSx6+UrOTum6jdt3wu5Frg2GGT",
	"X3/k/LvlNnvn2zJdTJ3fFnVQm0jqiF6lM2g6S2tpLhTQbuxJyCP5r0aHHAQelCOjF2GT1Bnnpzr/5keC",
	"YIBdycvQOGjM+TY7ExhVVxOUoMt+7uM/FzXz+BdMBBooHfilMKCF2a/btdy3L9rosF3nIeZjLpVoDvSg",
	"8eGloMQEUEdAdaT5UKSAK2/XajYUBFAMbYaCGILYSPbS61TixJ+a3xdGtBPi5YTo28A0TsMIp7LXL0Tp",
	"nCWhVv1lFfXOtMw0CfqYRFeWy5gnaqb2MxL9af9JaQzZSrMn0Tkfz70C+JlSudQAmtfjdTcXOEad0/Jy",
	"4b6IGjPJLmvUZ/C7tIopE4BBMkD8vXIOB4wK6lBPiSKpkSR3+5+5SuWjcIJcPtcom39gHwbqn5tdI64p",
	"3aMFJ6W8lKfrey2iER5Vr80EZKxgLRCYlHFcMAR963KfOSVPAmKPql9WgBhNc9K5vLiJO0nWpx52plZX",
	"61UoJHfGbnKg24L2fiSo5WEMpIzmecCloIACQDLVijdxpHoUXwQAQbtE0u1gKHis+UlNx4cCO9DzppLi",
	"CFIeeCN25Eo8LIeKJjczO5Rw6hkdxEi6j7kwVO7ORfnGqJQ2ZpWLlLMpFhMYnJcps5mWMmdCEVrY+B7k",
	"KGRemv5m4iJyUzsuKTLkDqF2UTv68Cu5mIsSGyKvUWqUXhrbT9u1khyR8hLlpRS2GLY63+f4yPjyEphL",
	"Wa4eyvRBDYKBM0TOyN51EAyUopRc5UpgMnbQRwJ6mIzsmPIxY5TxonZZBozK7ShSNihF/f5bKsX/iFya",
	"lW5YLle2IXOG/9AYXANtehIPc7EIRAyD/Fx0EBGUq/n/myEPQY7+0ShoVk/MDOX/b9f0Lwq+PcjRZWcd",
	"WJS78mlIRR+/2D1RXG4qB6olZFhM5XksUEKfUNfnEZVmXYBn+x8ZpnLYxMfodDY2zNNy8uDcGyOG+1Pb",
	"5/mLhRXcdmu0kQ38gKtc7wObxNQ6I3Yjf7uUgwi6kcYT2cp5C0ay/NtNfW9K+2AGfMKnA11X30pLzUnQ",
	"pEo/I0HVfGsdXh9Sm1/nxkzwjgPZAMSXW7YhrdaRtIp0gIk0jlLaHefDAnIr9frWLmg2m81W9eIVtra8",
	"x/321sXNQV3+1r5gR6cH7PwBfzg/v52Ex/C6eeJfn9H263W/8nW/4u7XX8t7Ny+l7RcbTIt3VnI5W3ZV",
	"mPMJZbabR3M1bhoALiBTJ5kYgt+2f8uD3+q/5aUe+1ul91vsdeghwAWV5x/kXQIJQMRh00CecdFIRXAp",
	"hohNcMJZ0UNAKJvI1SryzITpkrhfkieToVlIK33zV/wDTID6aMjTqrfbyFqyz/dQ9dqee8H6vBP2xtQL",
	"9UbNqdopxTkN23n8LTaDeDSSHT9236WkcZLwHcaD5I0vyUV9TIxnM44k+F3aEO+j6BNpqIDsqW3oSFkF",
	"mbi5y0LMxjZIAJl40pPYMBB7spS7ExzdtvcVWo+ubhJeriI4pAzsX3YSv+X1idHHSFoOkETXhpJoVIzW",
	"EIHfK2CIXoCLB1i8n5tL3UWqqAwk8vp+X0Jg1xPlgHFUjGw7QyIwRBDAqQ7gkmNnMEq0xetr+nOUavPa",
	"GNxGbr2e7GHx480RQwIWGxVYr5s2jO9D/lN8tZUwtwqFwt7BUfsCtA6ub9qH7Vbz5qBQKHS75LzdbpX3",
	"W61mDw+ak/Zec9C+bReLxW6XFAqFg4v9uS4/ENw6A866+kTk7h511fky8wYs2y9L5K9yrSR/uUY8oMTE",
	"BHveGqNeKsiukQpTc5DyQMyFSrjp42arUkW1+vZOATV2e4WtilstwFp9u1CrbG/X67VauVwurzZk1tF6",
	"4tXNoji+f1HL2qdiRfS0Gp/7yEMCZQWRDNWQFvrI0OxHmLirwxwVtlTTvJ7BSkYavrb7H7TTeklnxupY",
	"b1GqtWUlEeuuGQCjZo72fwV/6yGXr4EO+E/dGBVspK4rrDamAWHBVYhYHzroj2824T6iz3jl5Rx9xmot",
	"9ugnA9BSVJxDgvuIi5+KDz856I8jY949GY++fGVIwMh3/7MWRqXljJ4c6vtYWAMGfx9CLrU0rdnJHRDA",
	"NM9/R+SMtsgwcbxQxR5fHNxdNzeMnokRYbsG01HAa3LgtWltcTMmEH89G3OpzkCo0Pkgs62di2bL53px",
	"nN6Xb/NaRi8Zw7fWpdLmAXOWOLlErFtaHLMh8gqNXGa895q4VsHqMabnOq8vNOeH+V75ssB+KQQktr2z",
	"d3n+c6VqtMxF20HOBVzqhL66g5Nmg8r10lf9muti762OP0wyzVoDzuLqzX31wWyGkIfKOBgqQ1sAD0Eu",
	"gJhQNRDPq2v4aBB9jY3IGDNK5PjqZiLRokugI0LoAeNXjWNK1LzrcrvacDl9tqnw/Sfmz9DwbGcmj8dd",
	"vbT4+E92RRtyRJYSoRliTXgkX8wGWq9PCpF3KvFwwTDTA6UXuM6+HDBGmeVWBwmIlW9/XudNuUcht/od",
	"bWqvabwAgF5PwhTloeMgLtfSh9gLGcrlcyZ/Ri4o4ZKLGy5IzVnc88LKlqTOLIQfR0HZcaJFZs6KDly3",
	"xbkYMp5dFUWDRiHe6UtkdRHFpkXzk7ozUbN+FHBg9Y16/GnmgV6MNGDUAzdnHaDa4D52onvSeFKVlLbK",
	"d20WaDdYzJJ+JFFrybbE+2E8jU46WH4u2o1yJTStqIIDiwiHgw1n0Kk8VmtoFW4SsnADHz8emLN//nZE",
	"/h5J/Ei1XUgAmy0m8v8ZGrO7m0y+3txt+6f9C3tm2RxuvoZwWsS05E9NmlPJ7MfHJVibzwTMR0u2UptS",
	"q9a4mPyL3Euqu6OnQTCw3x/pz9FFk73ND11tmouOt7vLX353+dOuHTn3nn70UvHfmV2QznT6WYlKT8sj",
	"Sg9U/GuyTSrZJREfgglIW3JFcDNEHHVJqncyq0ge1i4KOPXGyGSOCobRGMXjF0Ezxq83zav4Xz77PLtl",
	"g2OTfIr9gLJEEMm/FkJf/zW7wuwSI7xnQnc9vM5LS2v+RSoZ5M9N6Pj5KVjfkSKyZvjUOjkeaw+1OkNj",
	"6Qjtq84mKRlR7NcCr2Zd6P+l8jKSSZxv6Rp/23SNdJbGzH2ZuOYLKBcDpq8X11dZ3lI+/hIpH+Yy+99y",
	"UCu2W/u07pKINS87AAuOvL6qEDPVgxGqCmXEJTzm/HEqgIKyLoFkauqwSEQnPfcqfNhBnL9XMEcTP3Ek",
	"ougDM+bCcjAHeEAoi3KZ1xK3/wEZK4lyACv7Jdv+QA7K+of/+jkl+xeHV144wEQfZ4vm6RJrzjqeIeR1",
	"r0bmCkExZ4gFckTI5kLLYqtrgY2/73Lkey435gXFD5P6nG00W8kcfPk0Yr6k8DyLs5gLTfkzb9xa1PcN",
	"cS+NSIlgstmAMyU9O7UptjC+J78JER4y9BRAFlX6W16U60C1B1HeHtAdQcIAAegFJ71EyUDsNRKgZqvR",
	"WVBx8pNJhsLuXyYLagbq0lSonXr9+1KhktGvC/lQLmbfmQ41h+E4FcpkRv0qBK+bE7VvTM+fEYCIY9fJ",
	"mgxsuiyLt5vzPU+D2KxIxBnqqmEJDWwQKAlG14jQSwCegZ9YCsbhONbjJPv3jEzeqda94qh8XZzloxS0",
	"H5VSrTf15+bizkXZQiUJkrKdG37ALKVypmItZ+ixDpc8ORLDJWfJGC6+XPtZN5+OkTKLJXaS93WyB0yU",
	"zLKcu+td3Dm6EoRpPjew/XJRLfnfEOilUf0j19WH+5eb5iC29y+NBwBQ0qOQrcpGdPGT3x88aXSrAOcn",
	"HzpP8oDN2Fcckqcg7D2N0PRpCPlwdStMOHKMure8pZTOs2DbRRc3JKE8+UMFrNTpEXvKLOe4QPzKRbUZ",
	"Qju6DEpchQRwJFRhuEwNepW+odOHVKT83Ni5/Frq998gM/wXamEr7ojfstLfstJtDLMkGf3JXoFb/ppc",
	"m+FWTEBvKhBPLqmyVdupNarbtUYa0tCA+pMz2J8yU9hnK5V6nLu43D5fksOSWOXMCWz0PfQiJKm99OXC",
	"x30orO42D/aQZ5fcP5j0b6Hxt3yctPM56V9W4jmxffrvLxtQmp28bFc2b1USNqyS8G0JajuJUb8LqxFY",
	"KphLl1CjTBoM8p8W7Y8nFBdrWZ7EeLNREvgUyCNIbIa7lLq0albdOD1pX8iNIyLYMHUqE++PUd2KDZC+",
	"h4kLYJxmTJCYUDYCOi5NJxmDV0qUNsaQhMoRQDDY72NHBfB1iRhSjuIeKUnAkRCYDGLNS45k09vsN5fJ",
	"jEzZMw/wQsXSaFolmmAQeFNVaiJZln42aUZ84RIWjYaP1Bnl5s6MW+6G5XLV0X3Uv9E/S/o3H/KR/uXL",
	"/+pfzpst/cP/4oAj8VH/qv6tf18dBWWjhaPW1Y/EC/ZCZ4RE9k0tJFqJlSpe56Z5sd+83gcdQRkcIOB4",
	"kHOwp4YoztclN38UzAwb1mCPE3TngknjaA8pNNVTDy5oUT8IBQIHZIBJFLPdJTdxkWg10FzZ9gkWQ2Nm",
	"HLWugAm1itJ/MVfHZ/p+S8ed65cCZpEns6MzvnCL6rl3yTsT+84KMMAFveVhiF294+8i5dlMJzVRkYJ6",
	"k3rvs9cJFlEpl6i/Jypox2uKjvlkKE0Cv5LrDT7Viw8xKqH8G7tq9ChJugg6CIE4OtCjoVscUDowMbhc",
	"k46qul2Kq7abQvnpKu1Kswg9gQsG8jgP2/EoR1xEdoHhP/K7KaYekacmzLjbe4lmR8ouklZo5pGMwg3e",
	"QLGLEYMXtW4QNVfKmBwlTck28lXkWewSlfBgiERh3cSEJQr1xLaMmcboc3cKAm1/cQAZ+tglABTAO2nf",
	"fPwD+RB72P327iNoEqD+AtB1GeJcW7QMBQxxZUXHczlyCDC3LK2OGuzlwTvoYQf9TyLu+l3RzGzOx6bu",
	"tyEMemozRNbc/rSg7pELMAj+BwYBD6goDkynqE8SJGVAb4oNs/7obQAJ1xwKXGkSWHHgUh9i8vEP/V85",
	"oWJP0AmxQED/Cn4PGPYhm75fnNzz9IRRFRBz0kJh+s5jZMZ676RK9W4OJjvXLSfN6D0FLRxUQQxIpl0S",
	"4bc7p7sqglugilysjEb0sO7m5Yy75OMimpV3XyE4+eMveYUpPnd/Xv18dTbL8Z/m04whdxBxIRGFHoPY",
	"LVTL1fpWdaUNnhguv6oc/1HkgdpAeVheFceIJe2jmvn2fqeBHv69tTLO6idZ5gb8/hLi7USY2wYadNRt",
	"hS2oklJcbS+sE0R3ELXX4Yhc9CgV63Y+jDtYlcSFOTZ+csGEYKy651DtluH6MLmyDUCwplNcMTrGXMer",
	"gdvrs7WyIqzQJTM1f31kiGbFyAGyMmHuZhro2B6d+7wyPLBzI1v9iriQ5MN/xmtTXrh8MC5Itch87Hos",
	"gvshItEDXuXkEy6yA5YHq48J9kO/S3T1HRf0pol2M19SjONaZbe2u71T2d3O8mFqdf2JBmvlGqctqVl3",
	"8y6YXbdWnjKVT6r7KVtFKa6Bh+ZfFjMprAL5UYmhLoGAowAyKRxNaxdJi0sru+qAxYIDOiHRFEVwbsbv",
	"ktkDWmYOaUVMkLSO+QyM6FtU70jK05FyBTDUJTwM9Im/QaicxtWNGnflQZrikhQDzFHpl4gbVRrtYuwQ",
	"DpCHyUqr0SzTJE2BqJux7obGzopjJfUoPWnwGZtQZSPHj2UUrYd1BEsQsuiVSYtPV3+MwxNMJx3O+C8F",
	"HqNU/CsBI+RxCIB2bCymL7shkjJvxhyqiRlU/TIbUMVFRgqkNhSyU53BfhjnWBL1Hhug/S7h1E+yofI3",
	"SzPShypaNCazaM4UoXWJQUIx4dyNVx6Rg9U3z3vUXyNdPLowfCfbK7p6Z0yf4kI8wdKqF3H/JaxuVpYC",
	"oAha6cj1ztX+ZynUZpyVWDsP3Jc1ikT1tJYcg5SfI38LCc7YJ0MrRVEoxdqJ0nFEwMaJ4ibFOpai6w2Q",
	"rjQ013mDc2x+nKXyKUr0TqNvo5zqvCZp/U8NtP53VBTXJF4v0HjijE9MBSdyGjjhhSEssGGIzV+Jf3IY",
	"xH++amD0Q3kIBjupL+k/Ev1URkVcHMX8FaWQmR9myRL53EDdPQyceICBVJlig0bHJyU7YCoKUt2DPS89",
	"tPwQT6z/SH+cH4XByWweKqx5ILl8zsPjNARKqYBeQYffU0dCPeaBFF+zfxXoGObyuQn3MrZIMvGpqV87",
	"dzu5kP30HV7cdjIhJT0+D11aIFSVgXQ3S0ENCRQCEXf9KOnTOMVlExU4kDxgie5Qv3MA2cAU9TAHiyQI",
	"lfzMgM6pUfV5pAolhVnKF0co98U/+pQ5aP3qjklr0UwQ18CcDa2/FFzUCwfrZaGfmoIt35GPP5v2UKfu",
	"tjwauoU9yDN8uSrZNt2zUq6Uy7vlnWLZ6p9UgUX2tOIRfcaWnGL58zDsrZONDflo3itRq9js98SjYDM4",
	"qqtfxzXgz6bKRyUzoxFnWPmSsTdRUbF5R4xkXlOCg6iiUQvxbESLId0ya/isM1XJ/XWwY6OpKMYvPWRG",
	"Hbx8/Iq7JdvZWGaLXwQV0LN9msOCqagXPf+uX13XnfOZIX959Zqst9kd1LIxMt/iNmFgT1Gg0IontFPN",
	"M+FGGzp/dKcVrp8RmqooxkXJ1EFGB4+aAA9OaZiOkAqttVg8SAahPW8iunXQCYcLT/3lTTgQk60IAj3k",
	"UB9xYLzMefXuK/oaKmNA6u6QIcCRQ4kLTXmLhDsXkafbTvH25rDQ+NF77DM6wA70surdbhL3E18QenrM",
	"ZGHev0o40MpSxhbYM0+8H4qJMVnfP620TFQ7RQ07C3+Yv1gj1EXPVuKevXwxxy/q9+wRK5V1Cy+bGWzY",
	"uGy1f1B8xSP8ktfbjUPv4x+Wl3AREVbXaFO9ia/cHSqKQsV14ZljAfSRcIaYDCI3QBG0pT6NzIXXv0Lm",
	"/UsZsEhEDqV8l2j/Saqkg/J2mWwrZftmhF7o8FhLsK6OVkNYJYBCU6oR/G42+SMoV7bLtV7Fhdtot17r",
	"udVar9FrVGCjWkd1uLPjVnrb5X4fvs/rAM4eg8QZFjw8QoDFdaNm47Eh8mZFaaSJ836OqhZb2HW0/mKC",
	"3hrdTBLp8uDifSQQ85UnZTJEBjX6Vjn1SrcPCRwgBn53IHE9FGDyHmAXEYHFFKg3HTR9qSAZqKzXhcce",
	"QIsSHvqIAUcSl6ptNV+4A3LgeFieEOk2Q0S6JKalmA6kLh8RVsZbEutHwM/nc/yVqgxnP+jz9mLP3/DF",
	"Hvs2WG3+DDV0xWKywcnPRl0G2RKouCrDgDZ2EnxPPxufRk9F/2y1wrjpJc0ZnbYIDrGHwMCjvZ6Jn4od",
	"rfkuQYMieKeqafBh4b/ezUl34YfWZ0Myn7O+NBfW8XPWS+CKnljveZCMdGVRXbEtUQUhGib13jq4x57r",
	"qHfDlfodLcesplbc2iouLKVarMLvv/82+7Uf57xZrjatpKAMXoH9rBy65W/poIBmjOthB5mU8XX13pSr",
	"xPLmgy8tHOs3+/mTIoO1FMtF94TOil+G8u8JtrDzSepB/MW0FUigMuMKglKP/zCpbF7QOysdf0F24YHv",
	"1lcj3bSzpx7aJ1ufrlURQR76S0RAxPNRUxByKYCaZ0eXH4+bnWN17ZR+8WgIK/Xtj/VKfafRcFHVdWu1",
	"2u6OU9lxa1s7lfp2o7q93auUq40y3O5t75R3+mW4tbtTru1UUc2V/9iGtb41Yy2Tk76PW/BAX/ktkf8/",
	"wjDmEmsV3+TjTVZbGmWDr/0KyHw+0aqnLZJv7qxqq5uZolxWRgm9QNtrPxSVDTmy58PtmS/K7JplVJu7",
	"4JlSv7RMyHRp+rk8zpQj1FyhC4ZQZJWpN8cyXM9PJmJSKUhL/cnz5UWi1a6D0CwLW5X+XMvMjlvaplPl",
	"ezIqzrik/xSomjR8jco655DENWy4GXKuPs+Tsd7WGy0a41sW2PMJTllBXCvLFy2b6GrVPJp2nqLHHpff",
	"FcfXavbJ1iPYlDO22CXNqBq8KsuldbV3pprtuzx4Nytwqv4yhVXfgdk6VKx1l/TQzLhSqp0q8KVH9LWa",
	"lg6cpczV8dgBQw5yleMB64pmOuQGcpV5Iw3qHh1bU2MSZXf/vGq7G1fXXS9hfBAMTMFsE7lvdmMmiWKX",
	"QYaXYFZ5dy7K9OoIjNB0luSIB2QWz6OM0LSTI3UmFwrxO1hXR1fg6nbvrN0CpwcPYO/ssnWqPndJl/if",
	"2hd7R02n49C9g+b+Wb/xcDxCryfb0PXOHyY78Oio7Z1ATzROnisvpb3K6Ydhu98OX45EcPe8g7rk7Hqw",
	"f7uz/Qxv6sHdft0/PD+pBiNE0HXJufG/fv00uph+4sPPFfrp8+Tg9bbT22pdnLf6raPB6HPjU6VLXh9H",
	"rO202GH5U2XCTnseDN3h7Qd8B0lzn/tbjYeDr7xXb95Wd1xxy86rnx7c+8Hu9YfP+Kp/17juktO955ty",
	"dXy3d+med/hDdfcMtsh2O9i6HAeN9gEttdHB3cPWV791edWEp+XeyXE17A9qrRCN+IebTpdMPt3foNbZ",
	"S/h4tn15/pleXp1Oxuef+i+9wdbn/cY4fCyfiueSc3FceYFh+cXnzXD3+CRAo/Hl1fWL1yXTr+J5+thn",
	"9A6jw2kweRyMP00EIeeN0qBzEJZO7m7YQ7le8Q9ub3ZaTm+nNnKOD28O++cjj4yOSl1S7t/WmtewXq4d",
	"V1+eyyPRQ9XxqXP1mV5dhqd7d/y4My6Xb48emtMrFE4/NHac29LDwfB8Z1Tt3J0+d8k2aj8Opvj8sjzx",
	"th6O9q9PndCbjPhu80PojQZb9KZX49VX/3F8Vd45ojcv97XKMzyt33c+XAwfEeqSxnb5M70b9pyt06Dz",
	"4bn/SJ85OxCPjave7eOHh/Fh4zpg7n2TPR/3TkaVk+D6tPlyM3zhn5p8b3i01SXls/Clcg/P98qDSrt+",
	"5Zy7JyXn6zMtNxyHPe99DvHLPcN1HO6efw4aX29K/c7rhc/d9oA0Sl8fT7sENz6FXj/c2Qm/Du9LE1Hp",
	"CYLF4Jp/fR6+nIfPD7e1x15tOBKHjeHpbenz551a5evwrH46aV43PzX3ukTsHx493l+PHf9gcLp/vnXa",
	"aTYe/btRr3oyPLs53zr7vDeF91tDh3jN6Hfn+GQM/btnt1Ufd4njOx/wp5PLvb3zvVazWTvEBwfoeNtn",
	"w8PjnfCOfzo7P6+UH+rO45C8PDQOm77iodbRpHHYmozaXbI3aR8dfqInrSZv7e09tJqTg9bx4KB1WGs2",
	"W4PRp1nvDxcPzdLO3kMw8Kad5uPD8fB5ejrsktKH/vbrVf9u3DuulA++VkftncvDvYsyOfv8Ye92yw/H",
	"nQ9fb8JO9f6M7VX96lHoieD0+uDk9Ez49YP9LtliR6+fm/RmaxrsPrQbZ81997zVupw+N585vb9t7Dzc",
	"hq0PpR55ZjfounJ2fdnqT69aO9v3u406vrzrEr/e+dDjn/YnO63KGfPc5nntfD+k08etDhZH8LF2+uns",
	"Tny4OYBbNcwfOket51e6c/XQuKueXI7q5S4ZfL0fNCoXpZ5fOXjt7Nw0qvcH+70tb/xca3vjl0H76yka",
	"bG29fn548dlD5/HkpNUfv/Y/eBed7fBlcNwlzy+lk/LUe6yc4d4R2z5qNqeXu7f3rPnYmXTOywfO801j",
	"ctAiL6POfjj96t9P7sYXe5/Dg/Zd4xJVH7rkHN9u9U8uGtzd2Q/44Uv9/MNnl5yTT50Px+z55up0v+rf",
	"M6/pkoOboftw13h+HAX3w/0pr5Z2d9FllwxHZXZGpuXni8kIhv0Svm1cOtufx+ej57Pr85NB/Xb37nR6",
	"Et7fi9fJZ/J8flG/vz7c+3pa44/UPz/vkr7o3RxvfahPe9f3pWZ1vNeDL9f3FbFz+3rx7LyiUefxAMOz",
	"i92z0rFz0mpfb306bGw3Kvtu0zs43HW7ZFQZfMIPnU9NCE/KJyfN1+Px9ej65OxscFp5+PSAjy/uphVR",
	"PZke9jmDfn3Sad1f9odXqD0927t5POmSMQsuvKse6vOb3frOTb+yd9EOB6+PrFW/e9nvnI4eB9fDrbuj",
	"caf9ibSmr6NP0+2D28rXqwDf13eljBpetT8/slPqnFZPzzq7Jfx68unm2hPP581/dMk/rvo3O+o1Rf2e",
	"4pKjJ6MqL2XoiXPPfki/VZZf/Sr20iuXn/VKdrJIqdWzKceLHAm6kqm6uEpoRZBLhYYDZXIlEvBU2YYu",
	"+T0K/HxvLZa6kIIVPeVBNywI/HPvqtLXUSDjNmrNgkKdzvGpVgw3sKutqmTTdeOYjOhew7x/DUMxpAy/",
	"IlfZM4sVaNZ6zrrZucdidHlcu23s1A5cvndLpqJX7U3G14PBsffJ6z189nbIVnm8m/GWiLWQza1+BDw2",
	"f3RaKedDtZA+ZWlPoOvj1a8Uq5n0q94267iDJD8aNxv/8xJmvqcoanaZ0aYkb2WlGR4k0NdRM1ytT+Ku",
	"CDraA8/Bf4FJ7JpXIfmqeR70QqESISXzGmcWn8ufWM1gv7hya4yE1YVb5/d28/Kt+iJBPXWu8YqJFtKS",
	"+dXbT/sXhxvWcY0uJ36ogOva9Ul+Qp0R0Jsm3ki3PJwTPTXg2g9Q0tZdtn5KAZKV0JC+Cs3mGwPjQz5a",
	"FxbZdiUkuiTLplixHg1Jd9mio3CNIt56hKQvTJ+FDmLC3aCzbL7Mm5bhJlzkOUbdMM4LXvoeyFzZ7O/0",
	"OC4Mkw39/EIXr1tCQZ/MY1lw7lZw+RE/vwv2oTWlP01DP+mdtejHaum6qv4GIKQuM+emdwQe60KeRrNI",
	"pXlz5DAkCvJTQl1VgfyUWQm9Bzl6sjr/Fn1/a6jAUTRHarisEoRR4ycd5/MUMPoyXXYZrkqBmPpiqrHJ",
	"TtSPIySyXpJ1IwUFbTPRXGiIfQmUDSBJ+JqT0fC1crVSs4dYOau11nghfQ8OojIzbOjowkca+ATkUWUY",
	"6HFqnpYwMpbHK5rTu7MwnS4BmnyIcUZsRSluEtu9Tow+8gMPiqzcyMWNi1epaziAaAC9gfpiMxshuld6",
	"6dkwqcifH4Ypg6hWQzKnLaSoKj/Px6kdSjBlgqFsWsZN4vWEDSLKo24rYsqJCDRUS+K/iQhA1Chl/5WL",
	"hDIxLEAfMezAYkCpVyQikPZ3Lp/bWvZ5I4Mx+YJEdkBP1CofaQRKS7i9aaUslttO6QDK3SbrZecsXriS",
	"6RrXxc37zkGrMp/5vbJPp7pZl4U6XSvneA0Z2qxLxguiq7pZEjhWdVkImV7VIete/NsXu1yOfCL6+efF",
	"tHhVjwpzwIc09FzAkIpP7KmneC77yjZb3CRdZUBlOwiV1mzZ+yJQ4/oIEhMKDT0PWBoCTXm8SyBD+ljQ",
	"Po+FeWHc1pwhY0xVUJi+M5QAdwkLPaQf5mGoTxnKgwkCQziOK6ApagYq61qurocAnMCo/jAWAHPyTnRJ",
	"QDnHPR2F7+MXFYnrQ+EM9eWl2Q8g6EB5aqS0jHkn6249UT1hvRCMJLriDNy1WWrNHvMVeDZgqDV72F+d",
	"XZs31myfEeGwAddGPb6snaWd7Benaa9TkMRUfdAVSbIezzaBPhHZfJkjsA3TqllISFbudKoIxQLdbryg",
	"H6wXYo93mhvyS+bRlZ0DXuTVOPk6SvVO5ktTBxeNiNG17yQCQy8omoox5i06OwqNc3GTuk/xY4cWO159",
	"3FrnSd8Fm2ktb+oFOzo9YOcP+MP5+e0kPIbXzRP/+oy2X6/7la/7FXe//lreu3kpbb8sy59KptshtmX3",
	"IBpLbUGZaUcBwLoB4AIyFTQvhuC37d/y4Lf6byob5bdK77f4fboeAnJ7VDZFl0ACEHHYNBDKY6ZHKoJL",
	"KZUnOPGsXQ8BYR7UVpXKZ1XsuyTulzamsm3MdQM+k4FuC3xl8tSedJ7a+o7LdL6fhSI2z7Cz2zp6huS7",
	"Rb/bExoGiCCmUIv7gPpYCOS+z8xfeqvdPRcLGgkq+0uGc7Q2TzU2sksQgKWwveIvlV8UEix4OhMQHOE9",
	"K72rZzywmHYk9Whq3UOQaanXU/86jBjn5P5Gmn+qpTTadbt41KEQQe7bN+Ut6VNbeq8uTymouZBTZWJ1",
	"boAun8OLuVScu6bfXDOAzhCBikrtV46B+OJ2MpkUofqsbktNX146a7cOLjoHhUqxXBwK39Pml1DIuOzs",
	"qelNIRcGVB1WAAOcCLz9mKtEr47KDx9z1WK5uJXTLzEoNJUcjxLES39g95uS+7ZKwUeGRPXpr2oGA3Nk",
	"S4pSGUJIRO/c63sAleWnKgIZNV4/9pa4QKRMkfSswJEq9idJXikLyNUVdeKXdNquBqUlIe5EikgAGfSR",
	"UEbzPxeE+H5cpiwCXlAwULWKMVFSVAyjeOWPOh1sRs/auaMlUvo82apUUa2+vVNAjd1eYaviVguwVt8u",
	"1Crb2/V6rVYul8urk6KkYcTMJYzajEq5nEj6NHU3PBNYV3o2DxHNAFqq2CawpMg5jZkkTiSJ1H7i1Kac",
	"0OKkbaLNJ0MZALt66q1fP3UzVI+MjJC6o8YaED179dfPfktm18ySAgPEJG2AmLY1JLU/A5IRoRMytwX1",
	"P2P3bwl6CXRqoSpRBaij3oJ2UyJccXEkvP/5RfJInOKjTuGkEFLCK6YnNU4p+kO91cBt2ci6SCkEBE2i",
	"rnkQULl0HOVAclMQXV1zjRGDkXBX8t44KxB0hrNXzhKuC74ouK4oF0ZWGyGDuNij7vTncbwePbqy/5Y+",
	"nKUw+7Ygb7Z+9uxt17b15qOqyqcUaeT+24QOi/DzJnneJM/akscIDZuk4aWVilP0FEfUQzkBp1FpxVh/",
	"yhvBojJclTkv1Xk4ll8oA30VemHXifTAZ/otsl+nVCSmseB5fplvPPbGYxue7osklOI0F0lGia0V/act",
	"TEn+PrNB1KEtDTRpDQhJIS4KEHEREeCZ9izHtR5hdmCvYWZEc6kn9RVc//lGhl6yRla2sRFhRqPlzep4",
	"k0t/K7k0L03mZNLPcZ1s4C2JsLjCTZKs8LuZBPu/5ipJYWqJ/HoTXG+C62/tLsmUX9oNnPSZWLwXsslG",
	"GlFCWP2FpMgv8LwkMKMG/rN9L4n546h+C0mptxPQZPbIU089MaAf2cnwyAj0Ikr6mdYUPPOoXVt61X7W",
	"BDbe/Jay2SVaUs8bLmEAl06ItL0zT/J900BRdfxiuWasPiaYDxOn+JIDORpnc6Ni1vFvdyBTRyBRmJUA",
	"nQEWz9PDBNqKmtjJOC5DGBVW1VFkMf7fzui3M/rvYVwkxUosVXRk5IyaF+WVZwqhf4/VsSCuwFKbA4uZ",
	"qZE3rhROFQum8r9gj4bCFP/goSeWeiol+G9GyWpXq8RThgyUJGCXf+pNLkJ1FIkTepCZt3LA72JIw8HQ",
	"xLGedC4v3hf/4w7+I/Uk7ICvwUY+JLiPuFjNS3HLNdjpGomQEa6qE0X9FDDqxtCoX8SwitJHzathcWOH",
	"KsaK39Mw2xe9mgYFSAaPmEewdK4/JCXzdyEarlhfwornMQre+HElP86QlaWYJLd7XcXkb85rafZYg+kS",
	"NSaX81xcdNyqZesHq9GLPDGTBxFT7IdcoL38PAqEM7wWByqp8LdlnBHB+cYYqxkjwtWbwv6msP8nK+wL",
	"smm1vOM96mcrGJGyAIHOWUo/O8hX6A1dMtccsriNeqFw9khi5hXB3uX5hoe/hEknOmkxB6Ix/o9cFajV",
	"Zkg69fH/2vE/W/Q8K7go4NQbo1LPC1HAzEM52W7mfdN+L27+a5y20TwbxcuVf8H02f7aqM2s3Iqqu/Vn",
	"H5XRDr6Fzi0emH+fO2yzh6pgLtOZojFHmjCbZP2g5Hm1cHDsJxr+6pizhblsjJJoA1IFl/5mioWJUVK+",
	"u+h5COBaVzcFblQ4Se6dmnXppinYzW7NHfW2Jc+alNRzgVnJqol2OmPrV56/szXYxEUcPWaQ8San/j2K",
	"veaAv59aD2MCknwYp9lH1DRjs9UxP5DELzBFDK0hmz3l1JsCpb/aGXX9G3Zkmv+Q6l39kxXpzK1UH0Dy",
	"tzcufuPiTbgYLVKQ5Nw4CTL7hLw0TX6Q7udSXhcXakBRskDa6nIIY6f/HT0hS5cjUa9rbpaSZSWz7b90",
	"kcpfZPzZq5z+ySZgRjlOy2bpliCCRGdJRzahO6uf+aeahTwC6s0o/JsahZ24Fq4hIuSm7lEoSahEqUq6",
	"GqC4WtmCdnIOMQG/m5qWmJL3IH78PZ36DgNcVM/4DXFfFz2EAS4pT2dB3WEiVjD+JFYaV5QVMv9+MBxg",
	"Mlg2ARdwgH5wGoVbIoBLfaiqLOtpVo3z5dv/DwAA//9U7fAh4vsAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
